/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { AcceptedLanguage } from '../../@coscine/model';
// @ts-ignore
import type { ApplicationProfileDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { ApplicationProfileDtoResponse } from '../../@coscine/model';
// @ts-ignore
import type { ApplicationProfileForCreationDto } from '../../@coscine/model';
// @ts-ignore
import type { ApplicationProfileForCreationDtoResponse } from '../../@coscine/model';
// @ts-ignore
import type { RdfFormat } from '../../@coscine/model';
/**
 * ApplicationProfileApi - axios parameter creator
 * @export
 */
export const ApplicationProfileApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ApplicationProfilesOptions: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/application-profiles`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Submits a request to create a new application profile.
         * @param {ApplicationProfileForCreationDto} [applicationProfileForCreationDto] The details required to create a new application profile.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createApplicationProfileRequest: async (applicationProfileForCreationDto?: ApplicationProfileForCreationDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/application-profiles/requests`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(applicationProfileForCreationDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves an application profile by its URI.
         * @param {string} profile The URI of the application profile to retrieve.
         * @param {RdfFormat} [format] The desired data format for the returned application profile.
         * @param {AcceptedLanguage} [acceptLanguage] The preferred language for the application profile data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getApplicationProfile: async (profile: string, format?: RdfFormat, acceptLanguage?: AcceptedLanguage, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'profile' is not null or undefined
            assertParamExists('getApplicationProfile', 'profile', profile)
            const localVarPath = `/api/v2/application-profiles/profiles/{profile}`
                .replace(`{${"profile"}}`, encodeURIComponent(String(profile)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (format !== undefined) {
                localVarQueryParameter['format'] = format;
            }


    
            if (acceptLanguage != null) {
                localVarHeaderParameter['Accept-Language'] = typeof acceptLanguage === 'string'
                    ? acceptLanguage
                    : JSON.stringify(acceptLanguage);
            }
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves all application profiles.
         * @param {string} [searchTerm] Gets or sets the search term used to filter application profiles.
         * @param {AcceptedLanguage} [language] Gets or sets the language for which the application profiles are requested.
         * @param {boolean} [modules] Gets or sets a value indicating whether to include modules in the application profiles.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getApplicationProfiles: async (searchTerm?: string, language?: AcceptedLanguage, modules?: boolean, pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/application-profiles/profiles`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (searchTerm !== undefined) {
                localVarQueryParameter['SearchTerm'] = searchTerm;
            }

            if (language !== undefined) {
                localVarQueryParameter['Language'] = language;
            }

            if (modules !== undefined) {
                localVarQueryParameter['Modules'] = modules;
            }

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves the `raw` application profile definition by its URI.
         * @param {string} profile The URI of the application profile.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getRawApplicationProfile: async (profile: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'profile' is not null or undefined
            assertParamExists('getRawApplicationProfile', 'profile', profile)
            const localVarPath = `/api/v2/application-profiles/profiles/{profile}/raw`
                .replace(`{${"profile"}}`, encodeURIComponent(String(profile)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ApplicationProfileApi - functional programming interface
 * @export
 */
export const ApplicationProfileApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ApplicationProfileApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2ApplicationProfilesOptions(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2ApplicationProfilesOptions(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ApplicationProfileApi.apiV2ApplicationProfilesOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Submits a request to create a new application profile.
         * @param {ApplicationProfileForCreationDto} [applicationProfileForCreationDto] The details required to create a new application profile.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createApplicationProfileRequest(applicationProfileForCreationDto?: ApplicationProfileForCreationDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ApplicationProfileForCreationDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createApplicationProfileRequest(applicationProfileForCreationDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ApplicationProfileApi.createApplicationProfileRequest']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves an application profile by its URI.
         * @param {string} profile The URI of the application profile to retrieve.
         * @param {RdfFormat} [format] The desired data format for the returned application profile.
         * @param {AcceptedLanguage} [acceptLanguage] The preferred language for the application profile data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getApplicationProfile(profile: string, format?: RdfFormat, acceptLanguage?: AcceptedLanguage, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ApplicationProfileDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getApplicationProfile(profile, format, acceptLanguage, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ApplicationProfileApi.getApplicationProfile']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves all application profiles.
         * @param {string} [searchTerm] Gets or sets the search term used to filter application profiles.
         * @param {AcceptedLanguage} [language] Gets or sets the language for which the application profiles are requested.
         * @param {boolean} [modules] Gets or sets a value indicating whether to include modules in the application profiles.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getApplicationProfiles(searchTerm?: string, language?: AcceptedLanguage, modules?: boolean, pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ApplicationProfileDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getApplicationProfiles(searchTerm, language, modules, pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ApplicationProfileApi.getApplicationProfiles']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves the `raw` application profile definition by its URI.
         * @param {string} profile The URI of the application profile.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getRawApplicationProfile(profile: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getRawApplicationProfile(profile, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ApplicationProfileApi.getRawApplicationProfile']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * ApplicationProfileApi - factory interface
 * @export
 */
export const ApplicationProfileApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ApplicationProfileApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ApplicationProfilesOptions(options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2ApplicationProfilesOptions(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Submits a request to create a new application profile.
         * @param {ApplicationProfileApiCreateApplicationProfileRequestRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createApplicationProfileRequest(requestParameters: ApplicationProfileApiCreateApplicationProfileRequestRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<ApplicationProfileForCreationDtoResponse> {
            return localVarFp.createApplicationProfileRequest(requestParameters.applicationProfileForCreationDto, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves an application profile by its URI.
         * @param {ApplicationProfileApiGetApplicationProfileRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getApplicationProfile(requestParameters: ApplicationProfileApiGetApplicationProfileRequest, options?: RawAxiosRequestConfig): AxiosPromise<ApplicationProfileDtoResponse> {
            return localVarFp.getApplicationProfile(requestParameters.profile, requestParameters.format, requestParameters.acceptLanguage, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves all application profiles.
         * @param {ApplicationProfileApiGetApplicationProfilesRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getApplicationProfiles(requestParameters: ApplicationProfileApiGetApplicationProfilesRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<ApplicationProfileDtoPagedResponse> {
            return localVarFp.getApplicationProfiles(requestParameters.searchTerm, requestParameters.language, requestParameters.modules, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves the `raw` application profile definition by its URI.
         * @param {ApplicationProfileApiGetRawApplicationProfileRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getRawApplicationProfile(requestParameters: ApplicationProfileApiGetRawApplicationProfileRequest, options?: RawAxiosRequestConfig): AxiosPromise<string> {
            return localVarFp.getRawApplicationProfile(requestParameters.profile, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for createApplicationProfileRequest operation in ApplicationProfileApi.
 * @export
 * @interface ApplicationProfileApiCreateApplicationProfileRequestRequest
 */
export interface ApplicationProfileApiCreateApplicationProfileRequestRequest {
    /**
     * The details required to create a new application profile.
     * @type {ApplicationProfileForCreationDto}
     * @memberof ApplicationProfileApiCreateApplicationProfileRequest
     */
    readonly applicationProfileForCreationDto?: ApplicationProfileForCreationDto
}

/**
 * Request parameters for getApplicationProfile operation in ApplicationProfileApi.
 * @export
 * @interface ApplicationProfileApiGetApplicationProfileRequest
 */
export interface ApplicationProfileApiGetApplicationProfileRequest {
    /**
     * The URI of the application profile to retrieve.
     * @type {string}
     * @memberof ApplicationProfileApiGetApplicationProfile
     */
    readonly profile: string

    /**
     * The desired data format for the returned application profile.
     * @type {RdfFormat}
     * @memberof ApplicationProfileApiGetApplicationProfile
     */
    readonly format?: RdfFormat

    /**
     * The preferred language for the application profile data.
     * @type {AcceptedLanguage}
     * @memberof ApplicationProfileApiGetApplicationProfile
     */
    readonly acceptLanguage?: AcceptedLanguage
}

/**
 * Request parameters for getApplicationProfiles operation in ApplicationProfileApi.
 * @export
 * @interface ApplicationProfileApiGetApplicationProfilesRequest
 */
export interface ApplicationProfileApiGetApplicationProfilesRequest {
    /**
     * Gets or sets the search term used to filter application profiles.
     * @type {string}
     * @memberof ApplicationProfileApiGetApplicationProfiles
     */
    readonly searchTerm?: string

    /**
     * Gets or sets the language for which the application profiles are requested.
     * @type {AcceptedLanguage}
     * @memberof ApplicationProfileApiGetApplicationProfiles
     */
    readonly language?: AcceptedLanguage

    /**
     * Gets or sets a value indicating whether to include modules in the application profiles.
     * @type {boolean}
     * @memberof ApplicationProfileApiGetApplicationProfiles
     */
    readonly modules?: boolean

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof ApplicationProfileApiGetApplicationProfiles
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof ApplicationProfileApiGetApplicationProfiles
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof ApplicationProfileApiGetApplicationProfiles
     */
    readonly orderBy?: string
}

/**
 * Request parameters for getRawApplicationProfile operation in ApplicationProfileApi.
 * @export
 * @interface ApplicationProfileApiGetRawApplicationProfileRequest
 */
export interface ApplicationProfileApiGetRawApplicationProfileRequest {
    /**
     * The URI of the application profile.
     * @type {string}
     * @memberof ApplicationProfileApiGetRawApplicationProfile
     */
    readonly profile: string
}

/**
 * ApplicationProfileApi - object-oriented interface
 * @export
 * @class ApplicationProfileApi
 * @extends {BaseAPI}
 */
export class ApplicationProfileApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ApplicationProfileApi
     */
    public apiV2ApplicationProfilesOptions(options?: RawAxiosRequestConfig) {
        return ApplicationProfileApiFp(this.configuration).apiV2ApplicationProfilesOptions(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Submits a request to create a new application profile.
     * @param {ApplicationProfileApiCreateApplicationProfileRequestRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ApplicationProfileApi
     */
    public createApplicationProfileRequest(requestParameters: ApplicationProfileApiCreateApplicationProfileRequestRequest = {}, options?: RawAxiosRequestConfig) {
        return ApplicationProfileApiFp(this.configuration).createApplicationProfileRequest(requestParameters.applicationProfileForCreationDto, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves an application profile by its URI.
     * @param {ApplicationProfileApiGetApplicationProfileRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ApplicationProfileApi
     */
    public getApplicationProfile(requestParameters: ApplicationProfileApiGetApplicationProfileRequest, options?: RawAxiosRequestConfig) {
        return ApplicationProfileApiFp(this.configuration).getApplicationProfile(requestParameters.profile, requestParameters.format, requestParameters.acceptLanguage, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves all application profiles.
     * @param {ApplicationProfileApiGetApplicationProfilesRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ApplicationProfileApi
     */
    public getApplicationProfiles(requestParameters: ApplicationProfileApiGetApplicationProfilesRequest = {}, options?: RawAxiosRequestConfig) {
        return ApplicationProfileApiFp(this.configuration).getApplicationProfiles(requestParameters.searchTerm, requestParameters.language, requestParameters.modules, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves the `raw` application profile definition by its URI.
     * @param {ApplicationProfileApiGetRawApplicationProfileRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ApplicationProfileApi
     */
    public getRawApplicationProfile(requestParameters: ApplicationProfileApiGetRawApplicationProfileRequest, options?: RawAxiosRequestConfig) {
        return ApplicationProfileApiFp(this.configuration).getRawApplicationProfile(requestParameters.profile, options).then((request) => request(this.axios, this.basePath));
    }
}

